
% Nzev BP: 
% CS: Analza zakiven ptee s vyuitm modernch senzor
% EN: Back-bone deformation analysis using modern sensors

% Kd pro pravu a zobrazen dat z dlouhodobho snmn v rmci BP
% Autor: Vojtch Fiala
% Datum: 26. 4. 2018
% Kd byl vytven v programu MATLAB R2015b (akademick verze)


%==========================================================================
%==========================================================================

% Vytn po pedchoz inosti
clear all; clc;
close all;

questdlg('Ped zadnm nzvu souboru s daty je nutno tento soubor zkoprovat do sloky s tmto kdem! Pi zadvn pozor na velk a mal psmena!!',...
    'Upozornn');

%=============== Nutno zadat nzev souboru!===============
%=============== Vzva probhne automaticky ==============
%=========================================================
input=inputdlg({'Nzev souboru is pponou (nap. DATA.txt)'},'Napi nzev souboru',[1 50],{'DATA.txt'});
                    % input='DATA.txt';
%=========================================================

% Naten dat ze souboru
pom=fopen(input{1,1});
data=textscan(pom,'%s');
sym=[];

% Zajitn, e budou vechny vektory stejn dlouh
h=round(length(data{1,1})/3)+7;
vektorx1=zeros(1,h);
vektorx2=zeros(1,h);
vektorx3=zeros(1,h);

vektory1=zeros(1,h);
vektory2=zeros(1,h);
vektory3=zeros(1,h);

% Inicializace hodnot pro konen vektory
v=1;
o=1;
p=1;

% Roztdn dat zskanch ze souboru
for i=1:length(data{1,1})
    for j=1:length(data{1,1}{i,1})
        if(data{1,1}{i,1}(j)==';')
            sym=[sym j];
        end
    end
    if(data{1,1}{i,1}(1)=='1')
        vektorx1(v)=str2num(data{1,1}{i,1}(sym(1)+1:sym(2)-1));
        vektory1(v)=str2num(data{1,1}{i,1}(sym(2)+1:end));
        v=v+1;
    elseif(data{1,1}{i,1}(1)=='2')
        vektorx2(o)=str2num(data{1,1}{i,1}(sym(1)+1:sym(2)-1));
        vektory2(o)=str2num(data{1,1}{i,1}(sym(2)+1:end));
        o=o+1;
    elseif(data{1,1}{i,1}(1)=='3')
        vektorx3(p)=str2num(data{1,1}{i,1}(sym(1)+1:sym(2)-1));
        vektory3(p)=str2num(data{1,1}{i,1}(sym(2)+1:end));
        p=p+1;
    end
    sym=[];
end

% prava hodnot prmrovacm filtrem o 3 prvcch
for k=2:length(vektorx1)-1
    x1(k-1)=mean(vektorx1(k-1:k+1));%+vektorx1(k)+vektorx1(k+1))/3
    x2(k-1)=mean(vektorx2(k-1:k+1));%+vektorx2(k)+vektorx2(k+1))/3;
    x3(k-1)=mean(vektorx3(k-1:k+1));%+vektorx3(k)+vektorx3(k+1))/3;
    y1(k-1)=mean(vektory1(k-1:k+1));%+vektory1(k)+vektory1(k+1))/3;
    y2(k-1)=mean(vektory2(k-1:k+1));%+vektory2(k)+vektory2(k+1))/3;
    y3(k-1)=mean(vektory3(k-1:k+1));%+vektory3(k)+vektory3(k+1))/3;
end

% Zobrazen graf pro jednotliv senzory
% Krn senzor:
figure
subplot(211)
plot(x1,'b')
title('Krn senzor');
ylabel('Sklon []');
xlabel('Zznamy [-]');
legend('Sklon v x-ose','Location','Best');
subplot(212)
plot(y1,'r')
ylabel('Nklon []');
xlabel('Zznamy [-]');
legend('Nklon v y-ose','Location','Best');

% Hrudn senzor:
figure
subplot(211)
plot(x2,'b')
title('Hrudn senzor');
ylabel('Sklon []');
xlabel('Zznamy [-]');
legend('Sklon v x-ose','Location','Best');
subplot(212)
plot(y2,'r')
ylabel('Nklon []');
xlabel('Zznamy [-]');
legend('Nklon v y-ose','Location','Best');

% Bedern senzor:
figure
subplot(211)
plot(x3,'b')
title('Bedern senzor');
ylabel('Sklon []');
xlabel('Zznamy [-]');
legend('Sklon v x-ose','Location','Best');
subplot(212)
plot(y3,'r')
ylabel('Nklon []');
xlabel('Zznamy [-]');
legend('Nklon v y-ose','Location','Best');

% Konec kdu pro zpracovn dat z dlouhodobho snmn.
%==========================================================================
